package ru.landgrafhomyak.db.sql_skeleton_0.api.table

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.misc._Selectable
import ru.landgrafhomyak.db.sql_skeleton_0.api.module.Module

public interface Table<out UE : Any, pUE : Any> : _Selectable<UE> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("uExt")
	public override val uExt: UE
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getName")
	public val name: String
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getModule")
	public val module: Module<*>

	public enum class TemporaryType {
		TRANSACTION_SCOPE,
		CONNECTION_SCOPE,
		MODULE_UPGRADE_SCOPE
	}

	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getTemporaryType")
	public val temporaryType: TemporaryType?
}